/* The update is done using the cluster algorithm of Swendsen and Wang,
   Phys Rev Lett 58, 86 (1987). The cluster labeling is done by the
   subroutine label_clusters() in clusters.c.
 */

#include "comext.h"
#include <stdio.h>

short newspin[MAXCLUSTERS];

SWupdate(nsweeps)
int nsweeps;
{
int i,j, n, isweep;
double pranf();

   for (isweep=0;isweep<nsweeps;isweep++) {

      /* Set up the bonds */

      num_accept = 0;
      for (i=0;i<isiz;i++) {
      for (j=0;j<jsiz;j++) {

            ibond[i][j] = 0;
	    if (J[i][j][0] > 0) {
               ibond[i][j] = (spin[i][j] == spin[plusi(1)][j]) && 
			            (pranf() < P[i][j][0]);
            }
	    else {
               ibond[i][j] = (spin[i][j] != spin[plusi(1)][j]) && 
			            (pranf() < P[i][j][0]);
	    }

            jbond[i][j] = 0;
	    if (J[i][j][1] > 0) {
               jbond[i][j] = (spin[i][j] == spin[i][plusj(1)]) && 
			            (pranf() < P[i][j][1]);
            }
	    else {
               jbond[i][j] = (spin[i][j] != spin[i][plusj(1)]) && 
			            (pranf() < P[i][j][1]);
	    }

	    if (ibond[i][j] > 1) {
		ibond[i][j] = 1;
		printf("ibond > 1\n"); fflush(stdout);
	    }
	    if (jbond[i][j] > 1) {
		jbond[i][j] = 1;
		printf("jbond > 1\n"); fflush(stdout);
	    }
	    num_accept += ibond[i][j] + jbond[i][j];
      }}

      /* Label the clusters */
      label_clusters();

      /* Assign a random spin value to each cluster
       * (actually here we are assigning a random CHANGE in 
       * the spin value, since in the frustrated case we may
       * be updating clusters containing different spins)
       */
      for (n=0;n<Nclusters;n++) {
	 newspin[n] = Q * pranf();
	 if (newspin[n] == Q) newspin[n] = 0;
      }

      /* Update the lattice */
      for (i=0;i<isiz;i++) {
      for (j=0;j<jsiz;j++) {
	 spin[i][j] = (spin[i][j] + newspin[cluster[i][j]]) % Q;
      }}

   }  /* end of loop over sweeps */

}

